unit ListBoxExtras;

interface

uses StdCtrls,Forms,SysUtils,Controls,Types,Graphics,Classes,tools,tools_file,dialogs;

  procedure FillSizeListBox(ListBox:TListBox);

  type
  TFontE = class
    public
      Farbliste:TSTringList;
      procedure DrawItem(Control: TWinControl; Index: Integer;  Rect: TRect; State: TOwnerDrawState);
      procedure MeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
      procedure FillFontListBox(ListBox1:TListBox);
      procedure FillColorListBox(ListBox1:TlistBox);
      procedure ColorDrawItem(Control: TWinControl; Index: Integer;  Rect: TRect; State: TOwnerDrawState);
      procedure ColorMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);

  end;

  implementation

var
  ListBox,ls2:TListBox;

procedure TFontE.ColorMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
begin
  with ls2.Canvas do begin
    Font.Color :=StringToColor(GetToken(Farbliste.Strings[index],'"',4));
    Font.Size := 4;
    Height := TextHeight(ls2.Items[Index]) + 2;
  end;
end;

procedure TFontE.ColorDrawItem(Control: TWinControl; Index: Integer;  Rect: TRect; State: TOwnerDrawState);
begin
  with ls2.Canvas do begin
    FillRect(Rect);
    Font.Color := StringToColor(GetToken(Farbliste.Strings[index],'"',4));
    Font.Size := 0;
    TextOut(Rect.Left, Rect.Top, ls2.Items[Index]);
  end;
end;

procedure FillSizeListBox(ListBox:TListBox);
var
  i:Integer;
begin
  ListBox.Clear;
  for i:=0 to 30 do
    ListBox.Items.Add(IntToStr(i));
end;

procedure TFontE.DrawItem(Control: TWinControl; Index: Integer;  Rect: TRect; State: TOwnerDrawState);
begin
   with ListBox.Canvas do begin
     FillRect(Rect);
     Font.Name := ListBox.Items[Index];
     Font.Size := 0;
     TextOut(Rect.Left+1, Rect.Top+1, ListBox.Items[Index]);
   end;
end;

procedure TFontE.MeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
begin
  with ListBox.Canvas do begin
    Font.Name := ListBox.Items[Index];
    Font.Size := 0;
    Height := TextHeight('Wg') + 2;
  end;
end;

procedure TFontE.FillColorListBox(ListBox1:TlistBox);
var
  i:Byte;
begin
  Farbliste:=TSTringList.Create;
  Farbliste.LoadFromFile(GetExeDir + 'farben.txt');

  ListBox1.Style:=lbOwnerDrawVariable;
  ls2:=ListBox1;

  for i:=0 to farbliste.Count-1 do
    ListBox1.Items.Add(GetToken(Farbliste.Strings[i],'"',2));

  ListBox1.OnDrawItem:=ColorDrawItem;
  ListBox1.OnMeasureItem:=ColorMeasureItem;

  ListBox1.repaint;
  ListBox1.Update;

end;

procedure TFontE.FillFontListBox(ListBox1:TListBox);
var
  i:Integer;
begin
  ListBox:=ListBox1;

  ListBox.Style:=lbOwnerDrawVariable;
  ListBox.Clear;
  ListBox.OnDrawItem:=DrawItem;
  ListBox.OnMeasureItem:=MeasureItem;

  for i:=0 to Screen.Fonts.Count-1 do
    ListBox.Items.add(Screen.Fonts[i]);
end;

end.
