unit myCanvas;

interface

uses NVCanvas,windows,Graphics,dialogs,jpeg,SysUtils,myCanvasImageList;

type
  TOninitDraw = procedure(w,h:Integer) of object;

  TMyCanvas = class
  private
    ox,oy,ow,oh:Integer;
    oldRec:TRect;
    oldtext:String;
    function BitMapLoad(FileName:TFileName;NewLoad:Boolean):Boolean;
  public
    Images:TListImage;
    bw,bh:Integer;
    Canvas:TNVCanvas;
    onDrawInit:TOninitDraw;
    BitMap:TBitMap;
    Graphic:TPicture;
    
    BitMapFile:String;
    constructor Create(h:HWND);
    procedure DrawRechtEck(x,y,w,h:Integer);
    procedure DrawKreis(x,y,r:Integer);
    procedure DrawText(x,y:Integer; Text:String;Format:DWORD = DT_EXTERNALLEADING or DT_NOCLIP);
    procedure DrawLine(x,y,w,h:Integer);
//    function BitMapLoad(FileName:TFileName;NewLoad:Boolean):Boolean;

    procedure DrawBitMap1(x,y,w,h:Integer;FileName:string;NewLoad:Boolean = False);
    procedure DrawBitMap2(ax,ay,aw,ah,qx,qy,qw,qh:Integer;FileName:string;isRaster:Boolean = False;NewLoad:Boolean = False; isOldClear:Boolean = False;const mode:DWORD = SRCCOPY);

    procedure SetStandartStyle;
    procedure SaveBackgrund(FileName:String);
  end;

implementation

uses Types;


procedure ConvertToBitmap(Source : TPicture; Bitmap : TBitmap);
begin
 if Bitmap = nil then
  Bitmap := TBitmap.Create
 else
   Bitmap.FreeImage;

 Bitmap.Width := Source.Width;
 Bitmap.Height := Source.Height;
 Bitmap.Canvas.Draw(0,0,Source.Graphic)
end;

function TMyCanvas.BitMapLoad(FileName:TFileName;NewLoad:Boolean):Boolean;
var
  e:Boolean;
begin
  e:=FileExists(FileName);
  if e = True then begin
    if BitMapFile <> FileName then begin
      if BitMap = NIL then begin
        BitMap:=TBitmap.Create;
        Graphic:=TPicture.Create;
      end
      else begin
        if NewLoad = True then begin
          // Neu Installisiern
          FreeAndNil(BitMap);
          FreeAndNil(Graphic);
          BitMap:=TBitmap.Create;
          Graphic:=TPicture.Create;
        end;
      end;
      BitMapFile:=FileName;
      if Pos('jpeg',FileName) > 0 then begin
        Graphic.LoadFromFile(FileName);
        ConvertToBitmap(Graphic,bitMap);
      end
      else begin
        FreeAndNil(BitMap);
        BitMap:=TBitMap.Create;
        bitMap.LoadFromFile(FileName);

      end;

    end
    else begin
      if NewLoad = True then
        BitMap.LoadFromFile(FileName);
    end;
  end;
  result:=e;
end; // BitMapLoad

procedure TMyCanvas.SaveBackgrund(FileName:String);
var
  g:TBitMap;
  rect1,Rect2:TRect;
begin
  g:=TBitMap.Create;
  g.Width:=640;
  g.Height:=480;

  rect1.Left:=0;
  rect1.Top:=0;
  rect1.Right:=640;
  rect1.Bottom:=480;

  rect2.Left:=0;
  rect2.Top:=0;
  rect2.Right:=640;
  rect2.Bottom:=480;

  canvas.CopyRect(Rect1,g.Handle,canvas.Handle,Rect2,SRCCOPY);
 // BitBlt(g.Handle,0,0,640,480,canvas.Handle,0,0,SRCCOPY);
  g.saveToFile('D:\Daten\eigene\delphi\Spiele\myCanvas\ShipGame\system\image\test1.bmp');
end;

procedure TMYCanvas.DrawBitMap2(ax,ay,aw,ah,qx,qy,qw,qh:Integer;FileName:string;isRaster:Boolean = False;NewLoad:Boolean = False;isOldClear:Boolean = False;const mode:DWORD = SRCCOPY);
var
  rect,rect1,t:TRect;
begin
  if BitMapLoad(FileName,NewLoad) then begin
    bw:=BitMap.Width;
    bh:=BitMap.Height;
    if Assigned(onDrawInit) then onDrawInit(BitMap.Width,BitMap.Height);
    if isRaster = True then begin
      qx:=(qx*qw)-qw;
      qy:=(qy*qh)-qh;
    end;

    if qw = - 1 then qw:=bw; if qh = -1 then qh:=bh;

    Rect.Left:=qx;
    Rect.Top:=qy;
    Rect.Right:=qw;
    Rect.Bottom:=qh;

    if aw = - 1 then aw:=bw; if ah = -1 then ah:=bh;

    Rect1.Left:=ax;
    Rect1.Top:=ay;
    Rect1.Right:=aw;
    Rect1.Bottom:=ah;
//    ShowMessage(ColorToString(BitMap.Canvas.Pixels[0,0]));
    // Lscht das alte bild
    if (isOldClear = True) and (IntersectRect(t,oldRec,Rect1)) then begin
      DrawRechtEck(0,0,oldRec.Right,oldRec.Bottom);
    end;

                                                                     //SRCAnd
//   BitBlt(C.Handle, 0, 0, Sprite.Width, Sprite.Height,Shape.Canvas.Handle, 0, 0, SRCAnd);

  // BitBlt(C.Handle, 0, 0, Sprite.Width, Sprite.Height,Sprite.Canvas.Handle, 0, 0, SRCInvert);

    BitBlt(canvas.Handle,ax,ay,aw,ah,BitMap.canvas.Handle,qx,qy, SRCAnd);
    BitBlt(canvas.Handle,ax,ay,aw,ah,BitMap.canvas.Handle,qx,qy, SRCInvert);

//    Canvas.CopyRect(Rect1,BitMap.canvas.Handle,Rect,mode	);
    oldRec.Left:=0;
    OldRec.Top:=0;
    OldRec.Bottom:=OldRec.Bottom+(ay+ah);
    OldRec.Right:=OldRec.Right+(ax+aw);
  end;
end; // DrawBitMap2

procedure TMYCanvas.DrawBitMap1(x,y,w,h:Integer;FileName:string;NewLoad:Boolean = False);
var
  rect,rect1:TRect;
begin
  if BitMapLoad(FileName, NewLoad) then begin
    bw:=BitMap.Width;
    bh:=BitMap.Height;
    if Assigned(onDrawInit) then onDrawInit(BitMap.Width,BitMap.Height);

    Rect.Left:=0;
    Rect.Top:=0;
    if w = -1 then
      Rect.Right:=BitMap.Width
    else
      Rect.Right:=w;

    if h = -1 then
      Rect.Bottom:=BitMap.Height
    else
      Rect.Bottom:=h;

    Rect1.Left:=x;
    Rect1.Top:=y;
    Rect1.Right:=BitMap.Width;
    Rect1.Bottom:=BitMap.Height;
    Canvas.CopyRect(Rect,canvas.Handle,BitMap.canvas.Handle,Rect1,cmSrcCopy	);
  end;
end; // DrawBitMap

procedure TMYCanvas.SetStandartStyle;
begin
  Canvas.Brush.Color:=clBlack;
  Canvas.Pen.Color:=clYellow;
  Canvas.Font.Color:=clLime;
end; // SetStyle

constructor TMyCanvas.Create(h:HWND);
begin
  freeAndNil(bitMap);
  Canvas:=TNVCanvas.create;
  Canvas.Handle:=GetDC(h);
  SetStandartStyle;
  ox:=-1; oy:=-1; ow:=-1; oy:=-1;
  oldtext:='';
  Images:=TListImage.Create;
end; // Create

procedure TMyCanvas.DrawRechtEck(x,y,w,h:Integer);
begin
  Canvas.Rectangle(x,y,x+w,y+h);
end; // DrawRechtEck

procedure TMyCanvas.DrawKreis(x,y,r:Integer);
begin
  canvas.Circel(x,y,r);
end; // DrawKreis

procedure TMyCanvas.DrawText(x,y:Integer; Text:String;Format:DWORD = DT_EXTERNALLEADING or DT_NOCLIP);
var
  pos:TRect;
  oldPenColor:TColor;
begin
  // Den Alten Text lschen 
  if (ox >=x) and (oy >=y) and(ow >=x+canvas.TextWidth(text)) and (oh >=y+canvas.TextHeight(text)) then begin
    oldPenColor:=canvas.pen.color;
    canvas.pen.color:=canvas.brush.color;
    canvas.Rectangle(ox,oy,ow,oh);
    canvas.pen.color:=oldPenColor;
  end;

  pos.Left:=x;
  pos.TOP:=y;
  pos.Bottom:=y+canvas.TextHeight(text);
  pos.Right:=x+canvas.TextWidth(text);
  canvas.DrawText(text,pos,Format);

  oldText:=text;
  ox:=pos.left;oy:=pos.top;ow:=pos.Right; oh:=pos.Bottom
end; // DrawText

procedure TMyCanvas.DrawLine(x,y,w,h:Integer);
begin
  canvas.MoveTo(x,y);
  canvas.LineTo(w,h);
end; // DrawLine

end.
