unit myFileDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, FileCtrl, Buttons,tools_file;

type
  TForm5 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DirectoryListBox1: TDirectoryListBox;
    FilterComboBox1: TFilterComboBox;
    DriveComboBox1: TDriveComboBox;
    FileListBox1: TFileListBox;
    Label5: TLabel;
    Edit1: TEdit;
    Bevel1: TBevel;
    Label6: TLabel;
    ListBox1: TListBox;
    SpeedButton1: TSpeedButton;
    Bevel2: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label7: TLabel;
    Label8: TLabel;
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton1Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure DirectoryListBox1Click(Sender: TObject);
    procedure FileListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    // nur erweiterungen die in diesem filter drinen stehen werden zugelassen
    filter:String;
    procedure AddFileTolist(s:TObject);
    { Public-Deklarationen }
  end;

var
  Form5: TForm5;


implementation

{$R *.dfm}

procedure TForm5.AddFileTolist(s:TObject);
var
  i,l:Integer;
  f:String;
begin
  if s is TFileListBox  then begin
    for i:=0 to FileListBox1.Items.Count-1 do begin
      f:=DirectoryListBox1.Directory+ '\'+FileListBox1.Items.strings[i];
      l:=ListBox1.Items.IndexOf(f);
      if (FileListBox1.Selected[i] = True) and (FileNameInTheList(f,Filter) = True) and (l =-1) then
        ListBox1.Items.Add(f)
      else begin
        if (l > -1) and (FileListBox1.Selected[i] = True) then begin
          l:=-1;
          ShowMEssage('Datei gibt es schon in der Liste !' + #13 + f);
          Continue;
        end;
      end;
    end;
  end;

  Label8.Caption:=IntToStr(ListBox1.items.Count);
end;

procedure TForm5.ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept:=True;
end;

procedure TForm5.ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  AddFileTolist(Source);
end;                        

procedure TForm5.SpeedButton2Click(Sender: TObject);
begin
  if MessageDlg('Liste wirklich leeren ?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    ListBox1.Items.Clear;
end;

procedure TForm5.SpeedButton3Click(Sender: TObject);
begin
  DirectoryListBox1.Directory:=Edit1.Text;
end;

procedure TForm5.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_return then SpeedButton3Click(Sender);

  if (key = vk_up) or (key = vk_down) then begin
    if key = vk_up then DirectoryListBox1.ItemIndex:=DirectoryListBox1.ItemIndex+1;
    if (key = vk_down) and (DirectoryListBox1.ItemIndex-1 > -1)then DirectoryListBox1.ItemIndex:=DirectoryListBox1.ItemIndex-1;

    Edit1.Text:=DirectoryListBox1.GetItemPath(DirectoryListBox1.ItemIndex);
    Edit1.SelStart:=StrLen(PChar(Edit1.Text));
  end;
end;

procedure TForm5.SpeedButton1Click(Sender: TObject);
begin
  if MessageDlg('Makirte Dateien wirklich aus der Liste lschen ?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    ListBox1.DeleteSelected;
    Label8.Caption:=IntToStr(ListBox1.items.Count);
  end;
end;

procedure TForm5.DirectoryListBox1Change(Sender: TObject);
begin
  Edit1.Text:=DirectoryListBox1.Directory;
end;

procedure TForm5.DirectoryListBox1Click(Sender: TObject);
begin
  Edit1.Text:=DirectoryListBox1.Directory;
end;

procedure TForm5.FileListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_return then AddFileTolist(FileListBox1);
  
end;

procedure TForm5.BitBtn1Click(Sender: TObject);
begin
  close;
  tag:=0;
end;

procedure TForm5.BitBtn2Click(Sender: TObject);
begin
  close;
  tag:=1;
end;

procedure TForm5.FormShow(Sender: TObject);
begin
  tag:=-1;
end;

end.
